unit serverthread;

interface

uses
  windows, scktcomp2, SysUtils, Classes, Forms, Receiverthread;

type
  EServerThread = class( Exception );
  // The serverthread is a descendant of the
  // TServerClientThread
  TServerThread = class( TServerClientThread )
    private
      owner: TForm;
      fSocketStream : TWinSocketStream;
      Receiverthread: TReceiverthread;
    public
     constructor Create(CreateSuspended: Boolean;
  ASocket: TServerClientWinSocket; _receiverThread: TReceiverThread; _form1: TForm);
      procedure ClientExecute; override;

      // The ClientExecute overrides the
      // TServerClientThread.ClientExecute
      // and contains the actual code that is
      // executed when the thread is started
  end;


implementation

uses unit1;


constructor TServerThread.Create(CreateSuspended: Boolean;
  ASocket: TServerClientWinSocket; _receiverThread: TReceiverThread; _form1: TForm);

begin
   receiverThread := _receiverThread;
   owner := _form1;
   inherited create(Suspended, ASocket);
end;

procedure TServerThread.ClientExecute;
var
   tmpBuf: array[0..65534] of byte;
   i, bytesRead: integer;
   form1: TForm1;
   str: string;
begin
   form1 := owner as TForm1;
  inherited FreeOnTerminate := TRUE;
  try
    fSocketStream := TWinSocketStream.Create( ClientSocket,
                                              100000 );
    try
      while ( not Terminated ) and ( ClientSocket.Connected ) do
      try
        if fSocketStream.WaitForData(10) then
        begin
           bytesRead := fSocketStream.Read(tmpBuf, sizeof(tmpBuf));
           receiverThread.handleReceivedBuffer(@tmpBuf[0], bytesRead);
         end;
      except on e:exception do
        begin
          // An error has occurred, close and exit
          ClientSocket.Close;
          Terminate;
        end;
      end;
    finally
      fSocketStream.Free;
    end;
  except on e:exception do
    begin
      // An error has occurred, close and exit
      ClientSocket.Close;
      Terminate;
    end;
  end;
end;

end.
